/*
 * UVC library (reference UVC gadget test application)
 *
 * Copyright (C) 2010 Ideas on board SPRL <laurent.pinchart@ideasonboard.com>
 * Copyright 2016 Sony Corporation
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 */
#ifndef __LIBGUVC_H__
#define __LIBGUVC_H__

#include <linux/types.h>

struct uvc_device;

struct uvc_ops {
	int (*fill_buffer)(struct uvc_device *, void *);
	int (*start_stream)(struct uvc_device *, __u32, __u32, __u32, __u32);
	int (*stop_stream)(struct uvc_device *);
};

void uvc_register_private_data(struct uvc_device *, void *);
void *uvc_device_to_priv(struct uvc_device *);
struct uvc_device *uvc_open(const char *devname);
void uvc_close(struct uvc_device *dev);
int uvc_start(struct uvc_device *dev);
int uvc_register_ops(struct uvc_device *dev, struct uvc_ops *ops);

#endif /* __LIBGUVC_H__ */
